/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PROCOMERCI                                              */
/* Tabela : PROCOMERCI                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 02/03/2007 - Rejane P. Leite                                               */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE TRIGGER DTULTATU_PROCOMERCI
BEFORE INSERT OR UPDATE OR DELETE
ON PROCOMERCI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRCO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPROCOMERCI,0 ) <> NVL(:NEW.CDPROCOMERCI,0)) OR
         (NVL(:OLD.NMPROCOMERCI,0 ) <> NVL(:NEW.NMPROCOMERCI,0)) THEN
         :NEW.DTULTATUPRCO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PROCOMERCI', '','CDPROCOMERCI='||:OLD.CDPROCOMERCI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PROCOMERCI MODIFY DTULTATUPRCO DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PROCOMERCI','5.03.010'); END;
/

