/* Descrio: A trigger impede a excluso de notas transmitidas eletronicamente */
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'BLOQ_DEL_NFE' AND
                 TYPE   = 'TR' 	              AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER BLOQ_DEL_NFE
GO
CREATE TRIGGER BLOQ_DEL_NFE
ON NOTAFISCAL
FOR DELETE
AS
/*VARIVEIS DO CURSOR C_CURSORT*/
   DECLARE @V_IDSTATUSNFE_OLD VARCHAR(1);
   DECLARE @V_IDNFGERADAVIAXML_OLD VARCHAR(1);
BEGIN
   DECLARE C_CURSORT CURSOR FOR
   SELECT IDSTATUSNFE, IDNFGERADAVIAXML
     FROM DELETED
    WHERE CDFILIAL+NRLANCTONF NOT IN (SELECT CDFILIAL+NRLANCTONF FROM INSERTED);

   OPEN C_CURSORT;
   FETCH NEXT FROM C_CURSORT INTO @V_IDSTATUSNFE_OLD, @V_IDNFGERADAVIAXML_OLD;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF ((@V_IDSTATUSNFE_OLD = 'A') OR (@V_IDSTATUSNFE_OLD = 'T') OR (@V_IDSTATUSNFE_OLD = 'D')) AND (@V_IDNFGERADAVIAXML_OLD = 'N') BEGIN
         RAISERROR('Operao bloqueada!Nota fiscal transmitida eletrnicamente', 16,1);
      END;
      FETCH NEXT FROM C_CURSORT INTO @V_IDSTATUSNFE_OLD, @V_IDNFGERADAVIAXML_OLD;
   END;
   CLOSE      C_CURSORT;
   DEALLOCATE C_CURSORT;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ BLOQ_DEL_NFE,'5.30.000';
GO

